import { Injectable } from '@angular/core';
import {ADMIN_INFO_OBJECT} from "./local-storage.namespace";

const storage = localStorage;

@Injectable({
  providedIn: 'root'
})
export class LocalStorageService {
  constructor() { }

  /**
   * 校验当前用户是否拥有按钮权限
   * @param btnCode
   */
  public isBtnCompetence(btnCode: string): boolean {
    let buttonList = [];
    buttonList = this.get(ADMIN_INFO_OBJECT)['buttonList'];
    if (buttonList != null && buttonList.length > 0) {
      if (buttonList.find(b => b.permissionCode === btnCode) != null) {
        return true;
      }
    }
    return false;
  }

  public get<T>(key: string): any {
    return JSON.parse(storage.getItem(key)) as T;
  }

  public getList<T>(key: string) {
    const before = storage.getItem(key);
    return before ? (JSON.parse(before) as T[]) : [];
  }

  public set(key: string, value: any): void {
    if (!value && value === undefined) { return; }
    const arr = JSON.stringify(value);
    storage.setItem(key, arr);
  }

  public clearAll() {
    storage.clear();
  }
}
